{{- if .Values.externalSecret.enabled -}}
apiVersion: external-secrets.io/v1beta1
kind: ExternalSecret
metadata:
  name: {{ include "application.name" . | quote }}
  labels:
    {{- include "application.labels" . | nindent 4 }}
    {{- with .Values.externalSecret.labels }}{{- toYaml . | nindent 4 }}{{- end }}
  annotations:
    {{- with .Values.common.annotations }}{{- toYaml . | nindent 4 }}{{- end }}
    {{- with .Values.externalSecret.annotations }}{{- toYaml . | nindent 4 }}{{- end }}
spec:
  refreshInterval: {{ .Values.externalSecret.refreshInterval }}
  secretStoreRef:
    kind: {{ .Values.externalSecret.secretStoreKind }}
    name: {{ .Values.externalSecret.secretStoreName | default .Release.Name }}
  target:
    name: {{ include "application.externalSecret.targetSecretName" . }}
    creationPolicy: {{ .Values.externalSecret.creationPolicy }}
  {{- with .Values.externalSecret.template }}
    template:
      engineVersion: v2
      {{- toYaml . | nindent 6 }}
  {{- end }}
  {{- with .Values.externalSecret.variables }}
  data:
    {{- range . }}
    - secretKey: {{ . }}
      remoteRef:
        key: {{ . }}
    {{- end }}
  {{- end }}
  {{- $decodingStrategy := .Values.externalSecret.decodingStrategy }}
  dataFrom:
  {{- with .Values.externalSecret.extract }}
    {{- range . }}
    - extract:
        key: {{ . }}
        decodingStrategy: {{ $decodingStrategy }}
    {{- end }}
  {{- end }}
  {{- with .Values.externalSecret.findRegex }}
    - find:
        name:
          regexp: {{ . }}
        decodingStrategy: {{ $decodingStrategy }}
      rewrite:
        - regexp:
            source: "{{ . }}(.*)"
            target: "$1"
  {{- end }}
  {{- with .Values.externalSecret.extraDataFrom }}
    {{- toYaml . | nindent 4 }}
  {{- end }}
{{- end }}